*
      SUBROUTINE PAR_GESVD1(NAME, M, N, NPROCS, MMIN, NB, NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)  
*          
*     PDGESVD1, PDGESVD4
*
      include 'mpif.h'
*
*  
      INTEGER            M, N, NPROCS, MMIN, NB, NPROW, NPCOL
      CHARACTER*(*)      NAME
*
*   -  
      INTEGER            NPR
      PARAMETER          ( NPR = 6 )
*
*  
      INTEGER            I, IPA, IPS, IPW, IPWOR, MP,
     $                   NP, NQ, NP0, NQ0, MYCOL, MYROW, MXLLDA,
     $                   MXNP, MXNQ, LWORK, LWMIN, MAXIM,
     $                   WORKSIZ, SIZE, SIZEB,
     $                   WATOBD, WBDTOSVD, WDBDSQR, WPDGEBRD, WPDLANGE
*
*  
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*
*  
      INTRINSIC          MAX, MIN, MOD, SQRT, INT, REAL
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
***      NPROCS1 = NPROW*NPCOL
*
      NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
      IF( NB0.LT.4 ) NB = 2
*1      NB0 = INT(REAL( N/NPROW) )
*1      IF( NB0.LT.4 ) NB = NB0
      IF( NB0.GE.4 .AND. NB0.LT.8 ) NB = 4
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 .AND. NB0.LT.64 ) NB = 32
      IF( NB0.GE.64 .AND. NB0.LT.128 ) NB = 64
      IF( NB0.GE.128 .AND. NB0.LT.256 ) NB = 128
      IF( NB0.GE.256 .AND. NB0.LT.512 ) NB = 256
      IF( NB0.GE.512 ) NB = 512
*
*      IA=JA= 1
*
      MXMP = NUMROC( M, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXMP
*
      MP = NUMROC( M, NB, MYROW, 0, NPROW )
      NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
      SIZE = MIN( M, N )
      SIZEB = MAX( M, N )
*
*     AMEM
*
*     A
      IPA = 1
*
*     S (   )
      IPS = IPA + MXLLDA*MXNQ
*     WORK
      IPWOR = IPS + SIZE
*
      MP0 = MXMP
      NQ0 = MXNQ
*
      MAXIM = MAX( MP0, NQ0 )
*
      WPDLANGE = MP
      WPDGEBRD = NB*( MP+NQ+1 ) + NQ
      WATOBD = MAX( MAX( WPDLANGE, WPDGEBRD ), MAXIM )
*
      WDBDSQR = MAX( 1, 2*SIZE )
      WBDTOSVD =  MAX( WDBDSQR, 0)
*
      LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD1(4)
      LWORK = LWMIN
*
*     W
      IPW = IPWOR + LWORK
*
      IF( NAME .NE. 'PDGESVD1' .AND. NAME .NE. 'PDGESVD4' ) GOTO 10
*
*     PDLAPRNT  .
*?
    3 WORKSIZ = MAX( NB, MP )
*
*        
*
      MMIN = IPW + WORKSIZ
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )M, N, NPROCS
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB, NB
         WRITE( NPR, FMT = * )' IPA,  IPS, IPWOR,  IPW,   MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPS, IPWOR, IPW, MMIN
*
      END IF
*
 9994 FORMAT( / I3,4I7 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '     '
     $      '     ', A8/ )
 9998 FORMAT( /'     A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'  '/)
 9993 FORMAT( / '       NB ',
     $       I2,' *',I2 // '     '/)
      RETURN
      END
